<template>
  <div id="enrollment-basic-setting-wrapper">
    <el-form :model="ruleForm" status-icon :rules="rules" ref="ruleForm" label-width="150px" class="ruleForm" style="width: 550px;">
      <el-form-item :label="$t('TEACHER_CLASS.CRS_NAME')" disabled>
        <el-input v-model="className" disabled></el-input>
      </el-form-item>
      <el-form-item :label="$t('TEACHER_CLASS.OPEN_COURSE')" prop="viewType">
        <el-switch v-model="ruleForm.viewType" @change="changeViewType"></el-switch>
      </el-form-item>
      <el-form-item v-if="ruleForm.type !== 4" :label="$t('TEACHER_CLASS.PERIOD_ENROLLMENT')">
        <el-col :span="11">
          <el-form-item prop="signUpStartTime">
            <el-date-picker type="date" :placeholder="$t('TEACHER_CLASS.START_DATE')" v-model="ruleForm.signUpStartTime" style="width: 100%;"></el-date-picker>
          </el-form-item>
        </el-col>
        <el-col :span="2" style="text-align: center; font-size: 1.5em;">~</el-col>
        <el-col :span="11">
          <el-form-item prop="signUpEndTime">
            <el-date-picker type="date" :placeholder="$t('TEACHER_CLASS.END_DATE')" v-model="ruleForm.signUpEndTime" style="width: 100%;"></el-date-picker>
          </el-form-item>
        </el-col>
      </el-form-item>
      <el-form-item v-if="ruleForm.viewType" :label="$t('TEACHER_CLASS.CRS_BEL_CODE')" prop="belongingCode" disabled>
        <el-input v-model="ruleForm.belongingCode" style="text-align: right; width: 315px;" disabled></el-input>
        <el-button type="primary" style="padding-left: 10px; padding-right: 10px; width: 80px;" @click="copyCode('public')">{{ $t('TEACHER_CLASS.COPY_CODE') }}</el-button>
      </el-form-item>
      <el-form-item v-else :label="$t('TEACHER_CLASS.CRS_PASSWORD')" prop="enrollmentPassword">
        <el-input v-model="ruleForm.enrollmentPassword" style="width: 220px;" disabled></el-input>
        <el-button @click="genPassword" type="primary" style="padding-left: 10px; padding-right: 10px; margin-left: 5px; width: 80px;">{{ $t('TEACHER_CLASS.CREATE_CODE') }}</el-button>
        <el-button type="primary" style="padding-left: 10px; padding-right: 10px; margin-left: 0px; width: 80px;" @click="copyCode('private')">{{ $t('TEACHER_CLASS.COPY_CODE') }}</el-button>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" @click="submitForm('ruleForm')" style="width: 80px;">{{ $t('TEACHER_CLASS.SET') }}</el-button>
        <el-button @click="resetForm()" style="width: 80px;">{{ $t('TEACHER_CLASS.RESET') }}</el-button>
      </el-form-item>
    </el-form>
  </div>
</template>

<script>
import classService from '../../services/classService';
import userService from '../../services/userService';
export default {
  name: 'EnrollmentBasicSetting',
  data() {
    const validateViewType = (rule, value, callback) => {
      return callback();
    };
    const validateSignUpStartTime = (rule, value, callback) => {
      const vm = this;
      if (!value) {
        vm.errorMessage.push('TEACHER_CLASS.ENTER_START_TIME');
        return callback(new Error(' '));
      } else if (new Date(value) >= new Date(vm.ruleForm.signUpEndTime)) {
        vm.errorMessage.push('TEACHER_CLASS.BEFORE_END_TIME');
        return callback(new Error(' '));
      } else {
        return callback();
      }
    };
    const validateSignUpEndTime = (rule, value, callback) => {
      const vm = this;
      if (!value) {
        vm.errorMessage.push('TEACHER_CLASS.ENTER_END_TIME');
        return callback(new Error(' '));
      } else if (new Date(value) <= new Date(vm.ruleForm.signUpStartTime)) {
        return callback(new Error(' '));
      } else {
        return callback();
      }
    };
    const validateBelongingCode = (rule, value, callback) => {
      return callback();
    };
    const validateEnrollmentPassword = (rule, value, callback) => {
      const vm = this;
      if (!value) {
        vm.errorMessage.push('TEACHER_CLASS.ENTER_PASSWORD');
        return callback(new Error(' '));
      } else if (value.length < 4) {
        vm.errorMessage.push('TEACHER_CLASS.PASSWORD_LENGTH');
        return callback(new Error(' '));
      } else {
        return callback();
      }
    };
    return {
      className: '',
      errorMessage: [],
      initialRuleForm: {
        viewType: true,
        signUpStartTime: Date.now(),
        signUpEndTime: Date.now() + 7 * 24 * 60 * 60 * 1000,
        belongingCode: '',
        enrollmentPassword: '',
        type: '',
      },
      ruleForm: {
        viewType: true,
        signUpStartTime: Date.now(),
        signUpEndTime: Date.now() + 7 * 24 * 60 * 60 * 1000,
        belongingCode: '',
        enrollmentPassword: '',
        type: '',
      },
      rules: {
        viewType: [
          { validator: validateViewType, trigger: 'blur' }
        ],
        signUpStartTime: [
          { validator: validateSignUpStartTime, trigger: 'blur' }
        ],
        signUpEndTime: [
          { validator: validateSignUpEndTime, trigger: 'blur' }
        ],
        belongingCode: [
          { validator: validateBelongingCode, trigger: 'blur' }
        ],
        enrollmentPassword: [
          { validator: validateEnrollmentPassword, trigger: 'blur' }
        ],
      },
    };
  },
  props: {
    classId: {
      type: Number,
    }
  },
  methods: {
    copyCode(type) {
      const vm = this;
      let CopyContent = document.createElement('textarea');
      switch (type) {
        case 'public': {
          CopyContent.value = `${vm.ruleForm.belongingCode}`;
          vm.$notify({
            title: vm.$t('TEACHER_CLASS.COPY_BELONGING_CODE'),
            message: vm.$t('TEACHER_CLASS.COPY_BELONGING_CODE_MSG'),
            duration: 7000,
            type: 'success',
          });
          break;
        }
        case 'private': {
          if (vm.ruleForm.enrollmentPassword === '') {
            vm.$notify({
              title: vm.$t('TEACHER_CLASS.COPY_PASSWORD'),
              message: vm.$t('TEACHER_CLASS.COPY_PASSWORD_ERROR_MSG'),
              duration: 3000,
              type: 'warning',
            });
            return;
          }
          CopyContent.value = vm.ruleForm.enrollmentPassword;
          vm.$notify({
            title: vm.$t('TEACHER_CLASS.COPY_PASSWORD'),
            message: vm.$t('TEACHER_CLASS.COPY_PASSWORD_MSG'),
            duration: 5000,
            type: 'success',
          });
          break;
        }
      };
      document.body.appendChild(CopyContent);
      CopyContent.select();
      document.execCommand("copy");
      document.body.removeChild(CopyContent);
    },
    submitForm(formName) {
      const vm = this;
      vm.errorMessage = [];
      this.$refs[formName].validate(async (valid) => {
        if (valid) {
          // 현재 상태 변경(DB상 = initialRuleForm)
          vm.initialRuleForm = vm.ruleForm;
          const putClass = await classService.NNputClass({
            id: vm.classId,
            openCheck: (vm.ruleForm.viewType ? 1 : 0),
            signUpStartDate: vm.ruleForm.signUpStartTime,
            signUpEndDate: vm.ruleForm.signUpEndTime,
          });
          if (!vm.ruleForm.viewType) {
            const changeEnrollPassword = await classService.postClassEnrollPassword({
              classId: vm.classId,
              password: vm.ruleForm.enrollmentPassword,
            });
          }
          vm.$notify({
            title: vm.$t('TEACHER_CLASS.BASIC_SETTING'),
            message: vm.$t('TEACHER_CLASS.SUCCESS'),
            duration: 3000,
            type: 'success',
          });
          return true;
        } else {
          vm.$notify({
            title: vm.$t('TEACHER_CLASS.BASIC_SETTING_ERROR'),
            message: vm.errorMessage.map(msg => vm.$t(msg)).join(', '),
            duration: 5000,
            type: 'error',
          });
          return false;
        }
      });
    },
    resetForm() {
      const vm = this;
      vm.ruleForm = JSON.parse(JSON.stringify(vm.initialRuleForm));
    },
    genRand1616() {
      return Math.random().toString(16).substr(2,16);
    },
    async genPassword() {
      const vm = this;
      const rand = vm.genRand1616();
      const exist = await classService.getClassEnrollPasswordByPassword({
        pwd: rand,
      });

      if (exist.data.class_enroll_password !== null) {
        vm.genPassword();
      } else {
        vm.ruleForm.enrollmentPassword = rand;
      }
    },
    // 강의 공개 여부 바뀌면 주제 수강신청 비밀번호 초기화
    changeViewType() {
      const vm = this;
      vm.ruleForm.class_enrollment_password = vm.initialRuleForm.class_enrollment_password;
    }
  },
  async mounted() {
    const vm = this;

    const class_data = await classService.getClassOnly({ id: vm.classId });
    const class_belonging = await classService.getClassBelongingByClassId({ classId: vm.classId });
    const class_enrollment_password = await classService.getClassEnrollPasswordById({ id: vm.classId });
    vm.className = class_data.data.name;
    vm.initialRuleForm.viewType = (class_data.data.view_type === 1); 
    vm.initialRuleForm.signUpStartTime = class_data.data.sign_up_start_time;
    vm.initialRuleForm.signUpEndTime = class_data.data.sign_up_end_time;
    vm.initialRuleForm.belongingCode = class_belonging.data.result[0] === undefined ? '' : class_belonging.data.result[0].belonging_pwd;
    vm.initialRuleForm.enrollmentPassword = class_enrollment_password.data.data === null ? '' : class_enrollment_password.data.data.password;
    vm.initialRuleForm.type = class_data.data.type;
    vm.ruleForm = JSON.parse(JSON.stringify(vm.initialRuleForm));
  }
};
</script>

<style>
#enrollment-basic-setting-wrapper{

}
</style>